// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: ValueMultiplySpeed.proto

package ru.omnicomm.pegasus.messaging.data.movement;

public final class ValueMultiplySpeedParser {
  private ValueMultiplySpeedParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public static final class ValueMultiplySpeed extends
      com.google.protobuf.GeneratedMessage {
    // Use ValueMultiplySpeed.newBuilder() to construct.
    private ValueMultiplySpeed() {
      initFields();
    }
    private ValueMultiplySpeed(boolean noInit) {}
    
    private static final ValueMultiplySpeed defaultInstance;
    public static ValueMultiplySpeed getDefaultInstance() {
      return defaultInstance;
    }
    
    public ValueMultiplySpeed getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.internal_static_ru_omnicomm_pegasus_messaging_data_movement_ValueMultiplySpeed_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.internal_static_ru_omnicomm_pegasus_messaging_data_movement_ValueMultiplySpeed_fieldAccessorTable;
    }
    
    // required int32 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private boolean hasSourceId;
    private int sourceId_ = 0;
    public boolean hasSourceId() { return hasSourceId; }
    public int getSourceId() { return sourceId_; }
    
    // optional int32 messageType = 2 [default = 60];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 60;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // required int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private boolean hasMessageTime;
    private int messageTime_ = 0;
    public boolean hasMessageTime() { return hasMessageTime; }
    public int getMessageTime() { return messageTime_; }
    
    // optional bool valid = 100 [default = true];
    public static final int VALID_FIELD_NUMBER = 100;
    private boolean hasValid;
    private boolean valid_ = true;
    public boolean hasValid() { return hasValid; }
    public boolean getValid() { return valid_; }
    
    // repeated double doubleValue = 204 [packed = true];
    public static final int DOUBLEVALUE_FIELD_NUMBER = 204;
    private java.util.List<java.lang.Double> doubleValue_ =
      java.util.Collections.emptyList();
    public java.util.List<java.lang.Double> getDoubleValueList() {
      return doubleValue_;
    }
    public int getDoubleValueCount() { return doubleValue_.size(); }
    public double getDoubleValue(int index) {
      return doubleValue_.get(index);
    }
    private int doubleValueMemoizedSerializedSize = -1;
    
    private void initFields() {
    }
    public final boolean isInitialized() {
      if (!hasSourceId) return false;
      if (!hasMessageTime) return false;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasSourceId()) {
        output.writeInt32(1, getSourceId());
      }
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasMessageTime()) {
        output.writeInt32(3, getMessageTime());
      }
      if (hasValid()) {
        output.writeBool(100, getValid());
      }
      if (getDoubleValueList().size() > 0) {
        output.writeRawVarint32(1634);
        output.writeRawVarint32(doubleValueMemoizedSerializedSize);
      }
      for (double element : getDoubleValueList()) {
        output.writeDoubleNoTag(element);
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasSourceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, getSourceId());
      }
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasMessageTime()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, getMessageTime());
      }
      if (hasValid()) {
        size += com.google.protobuf.CodedOutputStream
          .computeBoolSize(100, getValid());
      }
      {
        int dataSize = 0;
        dataSize = 8 * getDoubleValueList().size();
        size += dataSize;
        if (!getDoubleValueList().isEmpty()) {
          size += 2;
          size += com.google.protobuf.CodedOutputStream
              .computeInt32SizeNoTag(dataSize);
        }
        doubleValueMemoizedSerializedSize = dataSize;
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed result;
      
      // Construct using ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        if (result.doubleValue_ != java.util.Collections.EMPTY_LIST) {
          result.doubleValue_ =
            java.util.Collections.unmodifiableList(result.doubleValue_);
        }
        ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed other) {
        if (other == ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasValid()) {
          setValid(other.getValid());
        }
        if (!other.doubleValue_.isEmpty()) {
          if (result.doubleValue_.isEmpty()) {
            result.doubleValue_ = new java.util.ArrayList<java.lang.Double>();
          }
          result.doubleValue_.addAll(other.doubleValue_);
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 8: {
              setSourceId(input.readInt32());
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 24: {
              setMessageTime(input.readInt32());
              break;
            }
            case 800: {
              setValid(input.readBool());
              break;
            }
            case 1633: {
              addDoubleValue(input.readDouble());
              break;
            }
            case 1634: {
              int length = input.readRawVarint32();
              int limit = input.pushLimit(length);
              while (input.getBytesUntilLimit() > 0) {
                addDoubleValue(input.readDouble());
              }
              input.popLimit(limit);
              break;
            }
          }
        }
      }
      
      
      // required int32 sourceId = 1;
      public boolean hasSourceId() {
        return result.hasSourceId();
      }
      public int getSourceId() {
        return result.getSourceId();
      }
      public Builder setSourceId(int value) {
        result.hasSourceId = true;
        result.sourceId_ = value;
        return this;
      }
      public Builder clearSourceId() {
        result.hasSourceId = false;
        result.sourceId_ = 0;
        return this;
      }
      
      // optional int32 messageType = 2 [default = 60];
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 60;
        return this;
      }
      
      // required int32 messageTime = 3;
      public boolean hasMessageTime() {
        return result.hasMessageTime();
      }
      public int getMessageTime() {
        return result.getMessageTime();
      }
      public Builder setMessageTime(int value) {
        result.hasMessageTime = true;
        result.messageTime_ = value;
        return this;
      }
      public Builder clearMessageTime() {
        result.hasMessageTime = false;
        result.messageTime_ = 0;
        return this;
      }
      
      // optional bool valid = 100 [default = true];
      public boolean hasValid() {
        return result.hasValid();
      }
      public boolean getValid() {
        return result.getValid();
      }
      public Builder setValid(boolean value) {
        result.hasValid = true;
        result.valid_ = value;
        return this;
      }
      public Builder clearValid() {
        result.hasValid = false;
        result.valid_ = true;
        return this;
      }
      
      // repeated double doubleValue = 204 [packed = true];
      public java.util.List<java.lang.Double> getDoubleValueList() {
        return java.util.Collections.unmodifiableList(result.doubleValue_);
      }
      public int getDoubleValueCount() {
        return result.getDoubleValueCount();
      }
      public double getDoubleValue(int index) {
        return result.getDoubleValue(index);
      }
      public Builder setDoubleValue(int index, double value) {
        result.doubleValue_.set(index, value);
        return this;
      }
      public Builder addDoubleValue(double value) {
        if (result.doubleValue_.isEmpty()) {
          result.doubleValue_ = new java.util.ArrayList<java.lang.Double>();
        }
        result.doubleValue_.add(value);
        return this;
      }
      public Builder addAllDoubleValue(
          java.lang.Iterable<? extends java.lang.Double> values) {
        if (result.doubleValue_.isEmpty()) {
          result.doubleValue_ = new java.util.ArrayList<java.lang.Double>();
        }
        super.addAll(values, result.doubleValue_);
        return this;
      }
      public Builder clearDoubleValue() {
        result.doubleValue_ = java.util.Collections.emptyList();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeed)
    }
    
    static {
      defaultInstance = new ValueMultiplySpeed(true);
      ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeed)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_movement_ValueMultiplySpeed_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_movement_ValueMultiplySpeed_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\030ValueMultiplySpeed.proto\022+ru.omnicomm." +
      "pegasus.messaging.data.movement\"\203\001\n\022Valu" +
      "eMultiplySpeed\022\020\n\010sourceId\030\001 \002(\005\022\027\n\013mess" +
      "ageType\030\002 \001(\005:\00260\022\023\n\013messageTime\030\003 \002(\005\022\023" +
      "\n\005valid\030d \001(\010:\004true\022\030\n\013doubleValue\030\314\001 \003(" +
      "\001B\002\020\001BG\n+ru.omnicomm.pegasus.messaging.d" +
      "ata.movementB\030ValueMultiplySpeedParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_data_movement_ValueMultiplySpeed_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_movement_ValueMultiplySpeed_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_movement_ValueMultiplySpeed_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "Valid", "DoubleValue", },
              ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed.class,
              ru.omnicomm.pegasus.messaging.data.movement.ValueMultiplySpeedParser.ValueMultiplySpeed.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  public static void internalForceInit() {}
  
  // @@protoc_insertion_point(outer_class_scope)
}
